#ifndef beepblox_h
#define beepblox_h
	
	//#define BeepBloXDebug	//Uncomment for verbose debugging info
	#define CS_PIN	10
	#include "SimpleSDAudio.h"

	class BeepBloX //: public SdPlayClass
	{
		public:
		//Library Loads and plays a raw WAV file from the SD card
		//File must have sampling rate of 31.25kHz for playback speed to be correct
		//Card must not be fragmented (full format required if any files are deleted)
		BeepBloX();
		
		
		bool init(void); 
		
		//"Loads" a raw WAV file from the SD card
		//File must have sampling rate of 31.25kHz for playback speed to be correct PCM 8bit
		//Card must not be fragmented (full format required if any files are deleted)
		//Files must be 8.3 filename length
		bool setFile(String AudioFileName);

    //Lists all files found on the SD card
    //Returned via the serial port
    void listFiles();
		
		//Begins playback of the audio file 
		//Runs in the background via two interrupts 
		//(one for setting the raw PWM pin, and the other to load a chunk of the file from the SD card into the buffer)
		//waitdone: false = run in the background, code will continue
		//true = function will not exit until playback is complete
		bool play(bool waitdone=false);
		
		
		private:
		bool initialized=false;
		
			// Callback target, prints output to serial
			static void DirCallback(char *buf); 
			
    #ifdef BeepBloXDebug
			// helper function to determine free ram at runtime
			static int freeRam (); 
		#endif
		
	};
	
	
#endif

