#include "roboblox.h"

namespace RoboBloX
{
	void BlinkBloX(int pin, int data)
	{
		//pinMode(pin, OUTPUT);	//Done via mBlock
		digitalWrite(pin, data);
	}
	
	int LineBloX(int pin)
	{
		return analogRead(pin);
	}
	
	
	void TrafficBloX(Color color, int pinRd, int pinYw, int pinGn)
	{
		TrafficBloX((char)color, pinRd, pinYw, pinGn);
	}
	
	void TrafficBloX(char *null1, Color color, char *null2, int pinRd, int pinYw, int pinGn)
	{
		TrafficBloX(color, pinRd, pinYw, pinGn);
	}
	
	void TrafficBloX(char color, int pinRd, int pinYw, int pinGn)
	{
		pinMode(pinRd, OUTPUT);
		pinMode(pinYw, OUTPUT);
		pinMode(pinGn, OUTPUT);
		
		switch(color)
		{
			case RED: 
			case 'R':
			case 'r':
			digitalWrite(pinRd,HIGH);
			digitalWrite(pinYw,LOW);
			digitalWrite(pinGn,LOW);
			break;
			
			case YELLOW:
			case 'Y':
			case 'y':
			digitalWrite(pinRd,LOW);
			digitalWrite(pinYw,HIGH);
			digitalWrite(pinGn,LOW);
			break;
			
			case GREEN:
			case 'G':
			case 'g':
			digitalWrite(pinRd,LOW);
			digitalWrite(pinYw,LOW);
			digitalWrite(pinGn,HIGH);
			break;
			
			case NEXT: //BK->RD RD->GN GN->YW YW->RD  
			case 'N':
			case 'n':
			if(digitalRead(pinRd))			//RD->GN
			TrafficBloX(GREEN, pinRd, pinYw, pinGn);
			else if(digitalRead(pinGn))		//GN->YW
			TrafficBloX(YELLOW, pinRd, pinYw, pinGn);
			else if(digitalRead(pinYw))		//YW->RD
			TrafficBloX(RED, pinRd, pinYw, pinGn);
			else							//BK->RD
			TrafficBloX(RED, pinRd, pinYw, pinGn);		
			break;
			
			case BLACK: //Off
			case 'B':
			case 'b':
			case 'O':
			case 'o':
			default:
			digitalWrite(pinRd,LOW);
			digitalWrite(pinYw,LOW);
			digitalWrite(pinGn,LOW);
			break;
		}
	}

  //Returns the number of cm away from the sensor
  float BatBloX(int trig,int echo)
  {
    pinMode(trig,OUTPUT);
    pinMode(echo, INPUT);
    digitalWrite(trig,LOW);
    delayMicroseconds(2);
    digitalWrite(trig,HIGH);
    delayMicroseconds(10);
    digitalWrite(trig,LOW);
    return pulseIn(echo,HIGH,30000)/58.0;
  }

  void BeepBloX(int pin, String melody, int tempo)
  {
    //Note[#][octave=4][/duration=4][.]  Octave 0-8, Duration /1=Whole /2=Half /4=Quarter (default), .=1.5x duration R=Rest ( eg. C#5/8. D/16 )\n",
    //Add small gap between notes
  }
 
}

//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//-------Simple RoboBloX classes that do not need external libraries are implemented below----------
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


//-----GOBLOX-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//designed for PWM on pinLeftB & pinRightA
GoBloX::GoBloX(int pinLeftA, int pinLeftB, int pinRightA, int pinRightB):
_pinLeftA(pinLeftA), _pinLeftB(pinLeftB), _pinRightA(pinRightA), _pinRightB(pinRightB)
{
	pinMode(_pinLeftA, OUTPUT);
	pinMode(_pinLeftB, OUTPUT);
	pinMode(_pinRightA, OUTPUT);
	pinMode(_pinRightB, OUTPUT);

	//Both Wheels Stopped	
	digitalWrite(_pinLeftA,HIGH);
	digitalWrite(_pinLeftB,HIGH);
	digitalWrite(_pinRightA,HIGH);
	digitalWrite(_pinRightB,HIGH);
	speedLeft=0;
	speedRight=0;
	
}	

void GoBloX::driveDual(double left, double right)
{
	if(left!=speedLeft)	//Only update if the speed has changed
	{
		if(left>=100)	//Left Wheel: Forward Full Speed
		{
			digitalWrite(_pinLeftA,HIGH);
			digitalWrite(_pinLeftB,LOW);
		}
		else if(left>0) //Left Wheel: Forward % Speed
		{
			pwmLeft=left*2.55;
			digitalWrite(_pinLeftA,HIGH);
			analogWrite(_pinLeftB,255-pwmLeft);
			// analogWrite(_pinLeftA,pwmLeft);
			// digitalWrite(_pinLeftB,LOW);
		}
		else if(left==0) //Left Wheel: Stopped
		{
			digitalWrite(_pinLeftA,HIGH);
			digitalWrite(_pinLeftB,HIGH);
		}
		else if(left>-100) //Left Wheel: Reverse % Speed
		{
			pwmLeft=left*-2.55;
			digitalWrite(_pinLeftA,LOW);
			analogWrite(_pinLeftB,pwmLeft);
		}	
		else if(left<=-100) //Left Wheel: Reverse Full Speed
		{
			digitalWrite(_pinLeftA,LOW);
			digitalWrite(_pinLeftB,HIGH);
		}
		
		speedLeft = left;
	}
	
	
	if(right!=speedRight)	//Only update if the speed has changed
	{
		if(right>=100)	//Right Wheel: Forward Full Speed
		{
			digitalWrite(_pinRightA,HIGH);
			digitalWrite(_pinRightB,LOW);
		}
		else if(right>0) //Right Wheel: Forward % Speed
		{
			pwmRight=right*2.55;
			analogWrite(_pinRightA,pwmRight);
			digitalWrite(_pinRightB,LOW);
		}
		else if(right==0) //Right Wheel: Stopped
		{
			digitalWrite(_pinRightA,HIGH);
			digitalWrite(_pinRightB,HIGH);
		}
		else if(right>-100) //Right Wheel: Reverse % Speed
		{
			pwmRight=right*-2.55;
			analogWrite(_pinRightA,255-pwmRight);
			digitalWrite(_pinRightB,HIGH);
			// digitalWrite(_pinRightA,LOW);
			// analogWrite(_pinRightB,pwmRight);
		}	
		else if(right<=-100) //Right Wheel: Reverse Full Speed
		{
			digitalWrite(_pinRightA,LOW);
			digitalWrite(_pinRightB,HIGH);
		}
		
		speedRight = right;
	}
}	

void GoBloX::drive(Direction dir, int speed)
{
	drive((char)dir, speed);
}

void GoBloX::drive(int dir, int speed)
{
  drive((char)dir, speed);
}

void GoBloX::drive(char dir, int speed)
{
	switch(dir)
	{
		case FORWARD:	//1 Forward
		case '^':
		driveDual(speed, speed);
		break;
		
		case BACKWARD:	//2 Backward
		case 'v':
		case 'V':
		driveDual(-speed, -speed);
		break;
		
		case TURN_LEFT:	//3 Turn Left
		case '<':
		driveDual(0, speed);
		break;
		
		case TURN_RIGHT:	//4 Turn Right
		case '>':
		driveDual(speed, 0);
		break;
		
		case SPIN_LEFT:	//5 Spin Left (CCW)
		case '(':
		case '{':
		driveDual(-speed, speed);
		break;
		
		case SPIN_RIGHT:	//6 Spin Right (CW)
		case ')':
		case '}':
		driveDual(speed, -speed);
		break;
		
		case BACK_LEFT:	//7 Back Left
		case 'j':
		case 'J':
		driveDual(0, -speed);
		break;
		
		case BACK_RIGHT:	//8 Back Right
		case 'l':
		case 'L':
		driveDual(-speed, 0);
		break;
		
		case STOP:		//0 Stop
		case 'x':
    case 'X':
    case '0':
		default :	
		driveDual(0,0);
		break;
	}
	}
	//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
